import { ModelConditionUtil, ModelConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, SubTable } from 'model-util';
import { BMViewModelField } from './BMViewModelField';
/**
 * @author Keytop midend auto generate
 * @version 1.0
 * @date 2020-06-02 13:51
 */
interface BMViewModel {
    /**
    * 模型项目ID
    * @type { string }
    */
    bmProjectId?: string;
    /**
    * 构建方式 0:sql,1:手动创建,2:表名
    * @type { string }
    */
    buildMethod?: string;
    /**
    * 构建SQL
    * @type { string }
    */
    buildSql?: string;
    /**
    * 创建时间
    * @type { Date }
    */
    createTime?: Date;
    /**
    * 创建人ID
    * @type { string }
    */
    createUserId?: string;
    /**
    * 数据源ID
    * @type { string }
    */
    datasourceId?: string;
    /**
    * 描述
    * @type { string }
    */
    description?: string;
    /**
    * 主键
    * @type { string }
    */
    id?: string;
    /**
    * 模型名称
    * @type { string }
    */
    name?: string;
    /**
    * 是否已发布的
    * @type { boolean }
    */
    released?: boolean;
    /**
    * 表名
    * @type { string }
    */
    tableName?: string;
    /**
    * 更新时间
    * @type { Date }
    */
    updateTime?: Date;
    /**
    * 修改人ID
    * @type { string }
    */
    updateUserId?: string;
    /**
    * 版本ID
    * @type { string }
    */
    versionId?: string;
    /**
    * 版本ID
    * @type { string }
    */
    versionNo?: string;
    /**
    * 子表 BMViewModelField
    * @type { BMViewModelField[] }
    */
    bMViewModelField: BMViewModelField[];
}
interface BMViewModelMCU extends ModelConditionUtil<BMViewModelMCU> {
    BM_PROJECT_ID: FieldUtil<BMViewModelMCU>;
    BUILD_METHOD: FieldUtil<BMViewModelMCU>;
    BUILD_SQL: FieldUtil<BMViewModelMCU>;
    CREATE_TIME: FieldUtil<BMViewModelMCU>;
    CREATE_USER_ID: FieldUtil<BMViewModelMCU>;
    DATASOURCE_ID: FieldUtil<BMViewModelMCU>;
    DESCRIPTION: FieldUtil<BMViewModelMCU>;
    ID: FieldUtil<BMViewModelMCU>;
    NAME: FieldUtil<BMViewModelMCU>;
    RELEASED: FieldUtil<BMViewModelMCU>;
    TABLE_NAME: FieldUtil<BMViewModelMCU>;
    UPDATE_TIME: FieldUtil<BMViewModelMCU>;
    UPDATE_USER_ID: FieldUtil<BMViewModelMCU>;
    VERSION_ID: FieldUtil<BMViewModelMCU>;
    VERSION_NO: FieldUtil<BMViewModelMCU>;
}
declare class BMViewModelMCUImpl extends ModelConditionUtilImpl<BMViewModelMCUImpl> implements BMViewModelMCU {
    newInstance(): BMViewModelMCUImpl;
    get BM_PROJECT_ID(): FieldUtil<BMViewModelMCU>;
    get BUILD_METHOD(): FieldUtil<BMViewModelMCU>;
    get BUILD_SQL(): FieldUtil<BMViewModelMCU>;
    get CREATE_TIME(): FieldUtil<BMViewModelMCU>;
    get CREATE_USER_ID(): FieldUtil<BMViewModelMCU>;
    get DATASOURCE_ID(): FieldUtil<BMViewModelMCU>;
    get DESCRIPTION(): FieldUtil<BMViewModelMCU>;
    get ID(): FieldUtil<BMViewModelMCU>;
    get NAME(): FieldUtil<BMViewModelMCU>;
    get RELEASED(): FieldUtil<BMViewModelMCU>;
    get TABLE_NAME(): FieldUtil<BMViewModelMCU>;
    get UPDATE_TIME(): FieldUtil<BMViewModelMCU>;
    get UPDATE_USER_ID(): FieldUtil<BMViewModelMCU>;
    get VERSION_ID(): FieldUtil<BMViewModelMCU>;
    get VERSION_NO(): FieldUtil<BMViewModelMCU>;
}
declare class BMViewModelMU extends TableUtilImpl<BMViewModelMCU, BMViewModel> {
    tableName: string;
    tableFields: string[];
    modelFields: string[];
    modelIdFields: string[];
    tableIdFields: string[];
    idType: IdType;
    joinTables: any[];
    subTables: SubTable[];
    constructor();
    createModelConditionUtil(): BMViewModelMCU;
    static get BM_PROJECT_ID(): FieldUtil<BMViewModelMCU>;
    static get BUILD_METHOD(): FieldUtil<BMViewModelMCU>;
    static get BUILD_SQL(): FieldUtil<BMViewModelMCU>;
    static get CREATE_TIME(): FieldUtil<BMViewModelMCU>;
    static get CREATE_USER_ID(): FieldUtil<BMViewModelMCU>;
    static get DATASOURCE_ID(): FieldUtil<BMViewModelMCU>;
    static get DESCRIPTION(): FieldUtil<BMViewModelMCU>;
    static get ID(): FieldUtil<BMViewModelMCU>;
    static get NAME(): FieldUtil<BMViewModelMCU>;
    static get RELEASED(): FieldUtil<BMViewModelMCU>;
    static get TABLE_NAME(): FieldUtil<BMViewModelMCU>;
    static get UPDATE_TIME(): FieldUtil<BMViewModelMCU>;
    static get UPDATE_USER_ID(): FieldUtil<BMViewModelMCU>;
    static get VERSION_ID(): FieldUtil<BMViewModelMCU>;
    static get VERSION_NO(): FieldUtil<BMViewModelMCU>;
    get BM_PROJECT_ID(): FieldUtil<BMViewModelMCU>;
    get BUILD_METHOD(): FieldUtil<BMViewModelMCU>;
    get BUILD_SQL(): FieldUtil<BMViewModelMCU>;
    get CREATE_TIME(): FieldUtil<BMViewModelMCU>;
    get CREATE_USER_ID(): FieldUtil<BMViewModelMCU>;
    get DATASOURCE_ID(): FieldUtil<BMViewModelMCU>;
    get DESCRIPTION(): FieldUtil<BMViewModelMCU>;
    get ID(): FieldUtil<BMViewModelMCU>;
    get NAME(): FieldUtil<BMViewModelMCU>;
    get RELEASED(): FieldUtil<BMViewModelMCU>;
    get TABLE_NAME(): FieldUtil<BMViewModelMCU>;
    get UPDATE_TIME(): FieldUtil<BMViewModelMCU>;
    get UPDATE_USER_ID(): FieldUtil<BMViewModelMCU>;
    get VERSION_ID(): FieldUtil<BMViewModelMCU>;
    get VERSION_NO(): FieldUtil<BMViewModelMCU>;
}
export { BMViewModelMCU, BMViewModelMCUImpl, BMViewModel, BMViewModelMU };
